Index: branch/MORARD_Jordan/main.c
===================================================================
--- branch/MORARD_Jordan/main.c	(revision 378)
+++ branch/MORARD_Jordan/main.c	(revision 379)
@@ -1,7 +1,23 @@
+#include "trame.h"
+#include<math.h>
 #include <stdio.h>
 #include <stdlib.h>
 #include <strings.h>
-#include "trame.h"
+
+
+#define PI 3.14
+#define Rayon_Terre 6370
+
+
+typedef struct {
+    float lat;
+    float lon;
+}position;
+
+typedef struct {
+    position rpos;
+    float VitesseMax;
+    }zone;
 
 //Trames de tests à modifier si nécessaire.
 char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
@@ -12,17 +28,60 @@
                     "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
                     "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
                     "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
+                    0};
+
+position pos,pos1,pos2,pos3;
+
+//déclaration et initialisation de la distance
+float distance = 0.0;
+
+
+float latitude(char *ch)
+{
+    float res, res1, res2, res3;
+
+    res1 = decode_nombre(ch,17,2);      //retrouver les degrés en sexagesimal dans la trame
+    res2 = decode_nombre(ch,19,2);      //retrouver les minutes en sexagesimal dans la trame
+    res3 = decode_nombre(ch,22,4);      //retrouver les secondes en sexagesimal dans la trame
+
+    res = res1 + (res2 + res3/10000)/60;    //conversion sexagesimal à degrés
+
+    if(ch[27]=='S')     //identifier si la latitude est nord ou sud
+    {
+        res = -res;
+    }
+
+    return res;
+}
+
+float longitude(char *ch)       //meme principe que la fonction latitude
+{
+    float res, res1, res2, res3;
+
+    res1 = decode_nombre(ch,29,3);
+    res2 = decode_nombre(ch,32,2);
+    res3 = decode_nombre(ch,35,4);
+
+    res = res1 + (res2 + res3/10000)/60;
+
+    if(ch[40]=='W')     //identifier si la latitude est ouest ou est
+    {
+        res = -res;
+    }
+
+    return res;
+}
 
 //Fonction à modifier !!!!!
 void traitement(char * trame)
-{
-    static int cpt=0;
-    if (trame_cmp(trame, "GPGGA")==1)
+{
+    static int cpt = 0;
+    cpt++;
+    if(trame_cmp(trame,"GPGGA")==1)     //verifier si la trame GPS contient le caractere "GPGGA"
     {
-      printf ("> %s\n",trame);
-      cpt++;
-    }
+        printf ("> %s\n",trame);
+        printf("\nLatitude : %f    Longitude : %f \n\n ", decode_trame_latitude(trame), decode_trame_longitude(trame));
+    }
 }
 
 int trame_cmp(char * trame,char * type)
@@ -29,40 +88,15 @@
 {
     int i;
     int retour=1;
-    for(i=0;i<5;i++)
+    for(i=0;i<4;i++)
     {
-        if(trame[i + 1]!=type[i])
+        if(trame[i+1]!=type[i])
         {
             retour=0;
         }
     }
     return retour;
-}
-
-
-//Ajouter vos tests unitaires dans cette fonction.
-void tests_unitaires(void){
-    if (5!=5){
-        printf ("Erreur Test unitaire basique.\n");
-        exit(-1);
-    }
-    /*if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
-      printf ("Erreur Test unitaire trame_cmp.\n");
-      exit(-1);
-    }
-    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
-      printf ("Erreur Test unitaire trame_cmp.\n");
-      exit(-1);
-    }
-   if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
-      printf ("Erreur Test unitaire trame_cmp.\n");
-      exit(-1);
-    }
-   if (trame_cmp("$APRMC...", "GPGGA")!=0){
-      printf ("Erreur Test unitaire trame_cmp.\n");
-      exit(-1);*/
-
-   }
+}
 
 
 int decode_int(char c)
@@ -71,7 +105,7 @@
 
     nb = c-48;
 
-    if((nb<0)|(nb>9))
+    if((nb<0)||(nb>9))
     {
         return -1;
     }
@@ -82,6 +116,7 @@
 
 }
 
+
 int test_decode_int()
 {
 
@@ -139,13 +174,12 @@
     return 1;
 }
 
-int decode_nombre(char *ch,int n, int i)
+int decode_nombre(char *ch,int i, int n)
 {
+    int j;
     int res=0;
-    for(i;i<n;i++)
-    {
-        res=(res*10)+decode_int(ch[i]);
-    }
+    for(j=i;j<i+n;j++)
+        res=(res*10)+decode_int(ch[j]);
     return res;
 }
 
@@ -165,6 +199,149 @@
 
 }
 
+
+float decode_trame_latitude(char *ch)     //executer directement les deux fonctions pour retrouver la longitude et la latitude
+{
+    position p2;
+    p2.lat = latitude(ch);
+    return p2.lat
+}
+
+float decode_trame_latitude(char *ch)     //executer directement les deux fonctions pour retrouver la longitude et la latitude
+{
+    position p2;
+    p3.lat = latitude(ch);
+    return p3.lat
+}
+
+float calcul_distance(position *p1,position *p2)
+{
+    float D;
+    D = sqrt(pow((p2->latitude-p1->latitude)*PI*Rayon_Terre/180.0,2)+pow(((p2->longitude-p1->longitude)*(cos(((p2->latitude+p1->latitude)/2.0)*PI/180.0)*PI*Rayon_Terre/180.0)),2));        //formule calcul d'une distance sur une sphere, voir internet
+
+    return D;
+}
+
+float calcul_vitesse(position p1,position p2)
+{
+    float V;
+    V = calcul_distance(&p1,&p2)*3600;      //calcul de la vitesse avec la fonction calcul_distance entre 2 points séparés d'une seconde
+
+    return V;
+}
+
+//Ajouter vos tests unitaires dans cette fonction.
+void tests_unitaires(void)
+{
+    //test basique pour verifier bon fonctionnement du processeur
+    if (5!=5){
+        printf ("Erreur Test unitaire basique.\n");
+        exit(-1);
+    }
+
+    //4 tests pour la fonction trame_cmp pour bien avoir "GPGGA" en début de chaine
+    if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
+        printf ("Erreur Test unitaire trame_cmp 1.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC suite chaine","GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp 2.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$GPRMC... ", "GPRMC" )!=1){
+        printf ("Erreur Test unitaire trame_cmp 3.\n");
+        exit(-1);
+    }
+    if (trame_cmp("$APRMC...", "GPGGA")!=0){
+        printf ("Erreur Test unitaire trame_cmp 4.\n");
+        exit(-1);
+    }
+
+    //test decode_int
+    if(decode_int('5')!=5){
+        printf ("Erreur Test unitaire decode int.\n");
+        exit(-1);
+    }
+
+    //test decode_nombre
+    if(decode_nombre("7558",0,2)!=75){
+        printf ("Erreur Test unitaire decode nombre.\n");
+        exit(-1);
+    }
+
+    //test fonction latitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement
+    if(fabs(fabs(latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-45.75) > 10-6){
+        printf ("Erreur Test unitaire latitude.\n");
+        exit(-1);
+    }
+    //test fonction longitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement
+    if(fabs(fabs(longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-3.11006) > 10-6){
+        printf ("Erreur Test unitaire longitude.\n");
+        exit(-1);
+    }
+
+    //test decode_trame qui renvoie la latitude et la longitude, précision a 10e-6 près commme au dessus
+    decode_trame("$GPGGA,141914.00,4645.5624,N,00306.0000,E,1,05,3.4,499.3,M,,M,,*7D",&pos);
+    if(fabs(fabs(pos.latitude)-46.759373 >10-6)){
+        printf ("Erreur Test unitaire coordonnees 1.\n");
+        exit(-1);
+    }
+    if(fabs(fabs(pos.longitude)-3.100000 >10-6)){
+        printf ("Erreur Test unitaire coordonnees 2.\n");
+        exit(-1);
+    }
+
+    //declaration coordonnées de 3 villes pour les tests de calcul_distance
+    //Paris
+    pos1.latitude = 48.8588897;
+    pos1.longitude = 2.320041;
+
+    //Lyon
+    pos2.latitude = 45.7578137;
+    pos2.longitude = 4.8320114;
+
+    //Clermont-Ferrand
+    pos3.latitude = 45.777222;
+    pos3.longitude = 3.087025;
+
+    //test calcul_distance entre Paris et Lyon, voir si distance est dans l'intervalle que donne des infos sur internet
+    if((calcul_distance(&pos1,&pos2)>393) & (calcul_distance(&pos1,&pos2)<394))
+        {
+        printf("La distance Paris - Lyon est juste \n");
+        }
+    else{
+        printf ("Erreur Test unitaire calcul distance 1.\n");
+        exit(-1);
+    }
+    //test calcul_distance entre Lyon et Clermont-ferrand, voir si distance est dans l'intervalle que donne des infos sur internet
+    if((calcul_distance(&pos1,&pos3)>340) & (calcul_distance(&pos1,&pos3)<355))
+        {
+        printf("La distance Paris - Clermont est juste \n ");
+        }
+    else
+    {
+        printf ("Erreur Test unitaire calcul distance 2.\n");
+        exit(-1);
+    }
+
+    //declaration 2 points à latitude et longitude proche pour simuler une différence de position sur 1 seconde
+    position pos4;
+    pos4.latitude = 45.752911;
+    pos4.longitude = 3.110066;
+
+    position pos5;
+    pos5.latitude = 45.75298;
+    pos5.longitude = 3.11007;
+
+    //la vitesse est un floattant donc vérification de la précision de la mesure à 10e-2 près
+    if((calcul_vitesse(pos4,pos5)-27.51)<10-1){
+       printf (" Test unitaire calcul vitesse juste ! \n");
+    }
+    else {
+        printf ("Erreur Test unitaire calcul vitesse.\n");
+        exit(-1);
+    }
+}
 
 // Ne pas modifier cette fonction
 int main(int argc,char ** argv)