Index: branch/SENOUCI/sp4a12/main.c
===================================================================
--- branch/SENOUCI/sp4a12/main.c	(revision 392)
+++ branch/SENOUCI/sp4a12/main.c	(revision 393)
@@ -17,7 +17,7 @@
     float vitmax;
     }zone;
 
-//Trames de tests à modifier si nécessaire.
+/*Trames de tests à modifier si nécessaire.*/
 char * trames[]=  {"$GPGSV,3,2,10,15,03,077,,18,04,041,42,19,85,271,,20,08,214,*7C",
                     "$GPGSV,3,3,10,22,39,053,50,28,15,320,*7E",
                     "$GPRMC,141914.00,A,4545.6424,N,00306.6036,E,0.4,99.4,010206,,*0C",
@@ -28,7 +28,7 @@
                     "$GPZDA,141914.00,01,02,2006,00,00*69",
                     0};
 
-//description de toutes les zones
+/*description de toutes les zones*/
 zone zones[]= {
     {{44.7887762, -3.012}, 50},
     {{45.752610, 3.465067}, 60},
@@ -39,18 +39,17 @@
 
 int nombre_zone = 5;
 
-position pos,pos1,pos2,pos3;
+position pos,pos_prec;
 
-//déclaration et initialisation de la distance
-float distance = 0.0;
 
 int trame_cmp(char * trame,char * type)
 {
     int i;
     int ok=1;
+
     for(i=0;i<4;i++)
     {
-        if(trame[i+1]!=type[i])     //verifier si le début de la trame GPS est bien "GPGGA"
+        if(trame[i+1]!=type[i])     /*verifier si le début de la trame GPS est bien "GPGGA"*/
         {
             ok=0;
         }
@@ -61,9 +60,9 @@
 int decode_int(char c)
 {
     int nb;
-    nb = c-48;      //conversion caractere en ascii en nombre entier qui lui correspond
+    nb = c-48;      /*conversion caractere en ascii en nombre entier qui lui correspond*/
 
-    if((nb<0)||(nb>9))  //vérifier si le caracctère est un chiffre
+    if((nb<0)||(nb>9))  /*vérifier si le caracctère est un chiffre*/
     {
         return -1;
     }
@@ -73,7 +72,7 @@
     }
 }
 
-int decode_nombre(char *ch,int i,int n)     //meme principe que decode_int mais pour les nombres a plus de 1 chiffre
+int decode_nombre(char *ch,int i,int n)     /*meme principe que decode_int mais pour les nombres a plus de 1 chiffre*/
 {
     int res=0;
     int j;
@@ -88,13 +87,13 @@
 {
     float res, res1, res2, res3;
 
-    res1 = decode_nombre(ch,17,2);      //retrouver les degrés en sexagesimal dans la trame
-    res2 = decode_nombre(ch,19,2);      //retrouver les minutes en sexagesimal dans la trame
-    res3 = decode_nombre(ch,22,4);      //retrouver les secondes en sexagesimal dans la trame
+    res1 = decode_nombre(ch,17,2);      /*retrouver les degrés en sexagesimal dans la trame*/
+    res2 = decode_nombre(ch,19,2);      /*retrouver les minutes en sexagesimal dans la trame*/
+    res3 = decode_nombre(ch,22,4);      /*retrouver les secondes en sexagesimal dans la trame*/
 
-    res = res1 + (res2 + res3/10000)/60;    //conversion sexagesimal à degrés
+    res = res1 + (res2 + res3/10000)/60;    /*conversion sexagesimal à degrés*/
 
-    if(ch[27]=='S')     //identifier si la latitude est nord ou sud
+    if(ch[27]=='S')     /*identifier si la latitude est nord ou sud*/
     {
         res = -res;
     }
@@ -102,7 +101,7 @@
     return res;
 }
 
-float longitude(char *ch)       //meme principe que la fonction latitude
+float longitude(char *ch)       /*meme principe que la fonction latitude*/
 {
     float res, res1, res2, res3;
 
@@ -112,7 +111,7 @@
 
     res = res1 + (res2 + res3/10000)/60;
 
-    if(ch[40]=='W')     //identifier si la latitude est ouest ou est
+    if(ch[40]=='W')     /*identifier si la latitude est ouest ou est*/
     {
         res = -res;
     }
@@ -120,7 +119,7 @@
     return res;
 }
 
-decode_trame(char *ch, position *p)     //executer directement les deux fonctions pour retrouver la longitude et la latitude
+void decode_trame(char *ch, position *p)     /*executer directement les deux fonctions pour retrouver la longitude et la latitude*/
 {
     p->latitude = latitude(ch);
     p->longitude = longitude(ch);
@@ -129,7 +128,7 @@
 float calcul_distance(position *p1,position *p2)
 {
     float D;
-    D = sqrt(pow((p2->latitude-p1->latitude)*PI*rayon_terre/180.0,2)+pow(((p2->longitude-p1->longitude)*(cos(((p2->latitude+p1->latitude)/2.0)*PI/180.0)*PI*rayon_terre/180.0)),2));        //formule calcul d'une distance sur une sphere, voir internet
+    D = sqrt(pow((p2->latitude-p1->latitude)*PI*rayon_terre/180.0,2)+pow(((p2->longitude-p1->longitude)*(cos(((p2->latitude+p1->latitude)/2.0)*PI/180.0)*PI*rayon_terre/180.0)),2));        /*formule calcul d'une distance sur une sphere, voir internet*/
 
     return D;
 }
@@ -137,7 +136,7 @@
 float calcul_vitesse(position p1,position p2)
 {
     float V;
-    V = calcul_distance(&p1,&p2)*3600;      //calcul de la vitesse avec la fonction calcul_distance entre 2 points séparés d'une seconde
+    V = calcul_distance(&p1,&p2)*3600;      /*calcul de la vitesse avec la fonction calcul_distance entre 2 points séparés d'une seconde*/
 
     return V;
 }
@@ -147,14 +146,14 @@
     int i,j;
     float reference;
 
-    reference = calcul_distance(&p,&r[0].rpos);     //creation reference sur la premiere zone  du tableau pour commnencer la boucle
+    reference = calcul_distance(&p,&r[0].rpos);     /*creation reference sur la premiere zone  du tableau pour commencer la boucle*/
     for(i=0; i<nb_zones; i++)
     {
         *d=calcul_distance(&p,&r[i].rpos);
         if(*d<=reference)
         {
-            j=i;                //changement de l'indice de la zone la plus proche
-            reference=*d;       //changement de la reference en distance de la zone la plus proche
+            j=i;                /*changement de l'indice de la zone la plus proche*/
+            reference=*d;       /*changement de la reference en distance de la zone la plus proche*/
         }
     }
 
@@ -162,27 +161,58 @@
 
 }
 
-//Fonction à modifier !!!!!
+/*Fonction à modifier !!!!!*/
 void traitement(char * trame)
 {
-    static int cpt = 0;
+    static int cpt=0;
+    float v;
+    float d;
+    int zone_nb,trame_ok;
+    int alarme=0;
+    int seuil=1;
+
+    trame_ok=1;
     cpt++;
-    if(trame_cmp(trame,"GPGGA")==1)     //verifier si la trame GPS contient le caractere "GPGGA"
+    if(trame_cmp(trame,"GPGGA")==1)     /*verifier si la trame GPS contient le caractere "GPGGA"*/
     {
         printf ("> %s\n",trame);
+        if(trame_ok==1)
+        {
+            trame_ok=0;
+            decode_trame(trame,&pos);
+            if(&pos)
+            {
+                v=calcul_vitesse(pos,pos_prec);
+                zone_nb=distance_a_la_proche_zone(pos,zones,nombre_zone,&d);
+                if((d<seuil)&(v>zones[zone_nb].vitmax))
+                {
+                    alarme=1;
+                }
+                if(alarme==1)
+                {
+                    printf("alarme ON\n");
+                }
+                else
+                {
+                    printf("alarme OFF\n");
+                }
+                pos_prec=pos;
+            }
+            printf("vitesse : %.2f     distance : %.2f\n\n",v,d);
+        }
     }
 }
 
-//Ajouter vos tests unitaires dans cette fonction.
+/*Ajouter vos tests unitaires dans cette fonction.*/
 void tests_unitaires(void)
 {
-    //test basique pour verifier bon fonctionnement du processeur
+    /*test basique pour verifier bon fonctionnement du processeur*/
     if (5!=5){
         printf ("Erreur Test unitaire basique.\n");
         exit(-1);
     }
 
-    //4 tests pour la fonction trame_cmp pour bien avoir "GPGGA" en début de chaine
+    /*4 tests pour la fonction trame_cmp pour bien avoir "GPGGA" en début de chaine*/
     if (trame_cmp("$GPGGA suite chaine","GPGGA")!=1){
         printf ("Erreur Test unitaire trame_cmp 1.\n");
         exit(-1);
@@ -200,83 +230,88 @@
         exit(-1);
     }
 
-    //test decode_int
+    /*test decode_int*/
     if(decode_int('5')!=5){
         printf ("Erreur Test unitaire decode int.\n");
         exit(-1);
     }
 
-    //test decode_nombre
+    /*test decode_nombre*/
     if(decode_nombre("7558",0,2)!=75){
         printf ("Erreur Test unitaire decode nombre.\n");
         exit(-1);
     }
 
-    //test fonction latitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement
+    /*test fonction latitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement*/
     if(fabs(fabs(latitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-45.75) > 10-6){
         printf ("Erreur Test unitaire latitude.\n");
         exit(-1);
     }
-    //test fonction longitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement
+    /*test fonction longitude pour savoir si elle est bien précise à 10e-6 près, deux floattants ne peuvent pas être comparés directement*/
     if(fabs(fabs(longitude("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D"))-3.11006) > 10-6){
         printf ("Erreur Test unitaire longitude.\n");
         exit(-1);
     }
 
-    //test decode_trame qui renvoie la latitude et la longitude, précision a 10e-6 près commme au dessus
-    decode_trame("$GPGGA,141914.00,4645.5624,N,00306.0000,E,1,05,3.4,499.3,M,,M,,*7D",&pos);
-    if(fabs(fabs(pos.latitude)-46.759373 >10-6)){
+    /*test decode_trame qui renvoie la latitude et la longitude, précision a 10e-6 près commme au dessus*/
+    position pos1;
+    decode_trame("$GPGGA,141914.00,4645.5624,N,00306.0000,E,1,05,3.4,499.3,M,,M,,*7D",&pos1);
+    if(fabs(fabs(pos1.latitude)-46.759373 >10-6)){
         printf ("Erreur Test unitaire coordonnees 1.\n");
         exit(-1);
     }
-    if(fabs(fabs(pos.longitude)-3.100000 >10-6)){
+    if(fabs(fabs(pos1.longitude)-3.100000 >10-6)){
         printf ("Erreur Test unitaire coordonnees 2.\n");
         exit(-1);
     }
 
-    //declaration coordonnées de 3 villes pour les tests de calcul_distance
-    //Paris
-    pos1.latitude = 48.8588897;
-    pos1.longitude = 2.320041;
+    /*declaration coordonnées de 3 villes pour les tests de calcul_distance*/
+    /*Paris*/
+    position pos2;
+    pos2.latitude = 48.8588897;
+    pos2.longitude = 2.320041;
 
-    //Lyon
-    pos2.latitude = 45.7578137;
-    pos2.longitude = 4.8320114;
+    /*Lyon*/
+    position pos3;
+    pos3.latitude = 45.7578137;
+    pos3.longitude = 4.8320114;
 
-    //Bordeaux
-    pos3.latitude = 44.841225;
-    pos3.longitude = -0.5800364;
+    /*Bordeaux*/
+    position pos4;
+    pos4.latitude = 44.841225;
+    pos4.longitude = -0.5800364;
 
-    //test calcul_distance entre Paris et Lyon, voir si distance est dans l'intervalle que donne des infos sur internet
-    if((calcul_distance(&pos1,&pos2)>393) & (calcul_distance(&pos1,&pos2)<394)){}
+    /*test calcul_distance entre Paris et Lyon, voir si distance est dans l'intervalle que donne des infos sur internet*/
+    if((calcul_distance(&pos2,&pos3)>393) & (calcul_distance(&pos2,&pos3)<394)){}
     else{
         printf ("Erreur Test unitaire calcul distance 1.\n");
         exit(-1);
     }
-    //test calcul_distance entre Paris et Bordeaux, voir si distance est dans l'intervalle que donne des infos sur internet
-    if((calcul_distance(&pos1,&pos3)>498) & (calcul_distance(&pos1,&pos2)<499)){}
+    /*test calcul_distance entre Paris et Bordeaux, voir si distance est dans l'intervalle que donne des infos sur internet*/
+    if((calcul_distance(&pos2,&pos4)>498) & (calcul_distance(&pos2,&pos4)<499)){}
     else{
         printf ("Erreur Test unitaire calcul distance 2.\n");
         exit(-1);
     }
 
-    //declaration 2 points à latitude et longitude proche pour simuler une différence de position sur 1 seconde
-    position pos4;
-    pos4.latitude = 45.752911;
-    pos4.longitude = 3.110066;
-
+    /*declaration 2 points à latitude et longitude proche pour simuler une différence de position sur 1 seconde*/
     position pos5;
-    pos5.latitude = 45.75298;
-    pos5.longitude = 3.11007;
+    pos5.latitude = 45.752911;
+    pos5.longitude = 3.110066;
 
-    //la vitesse est un floattant donc vérification de la précision de la mesure à 10e-2 près
-    if((calcul_vitesse(pos4,pos5)-27.51)>1e-2){
+    position pos6;
+    pos6.latitude = 45.75298;
+    pos6.longitude = 3.11007;
+
+    /*la vitesse est un floattant donc vérification de la précision de la mesure à 10e-2 près*/
+    if((calcul_vitesse(pos5,pos6)-27.51)>1e-2){
         printf ("Erreur Test unitaire calcul vitesse.\n");
         exit(-1);
     }
 
-    //test fonction distance_a_la_proche_zone avec l'indice de la zone la plus proche dans le test, la zone 3 correspond a la 4eme zone du tableau zones[]
-    if(distance_a_la_proche_zone(pos4,zones,nombre_zone,&distance)!=3){
+    /*test fonction distance_a_la_proche_zone avec l'indice de la zone la plus proche dans le test, la zone 3 correspond a la 4eme zone du tableau zones[]*/
+    float distance = 0.0;
+    if(distance_a_la_proche_zone(pos5,zones,nombre_zone,&distance)!=3){
         printf ("Erreur Test unitaire calcul distance_a_la_proche_zone.\n");
         exit(-1);
     }
@@ -283,13 +318,13 @@
 }
 
 
-// Ne pas modifier cette fonction
+/* Ne pas modifier cette fonction*/
 int main(int argc,char ** argv)
 {
 
     tests_unitaires();
 
-    // Affichage des trames definies dans la table trames.
+    /* Affichage des trames definies dans la table trames.*/
     printf ("Trames de tests tableau trames:\n");
     int i=0;
     while (trames[i])
@@ -297,7 +332,7 @@
 
     if (!trame_init())
         exit(-1);
-    // Affichage des trames du fichier gps.log
+    /* Affichage des trames du fichier gps.log*/
     char *trame;
     printf ("Trames de tests du fichier gps.log\n");
     while  ((trame = trame_suivante()))