Index: branch/clara_soulard/sp4a12/main.c
===================================================================
--- branch/clara_soulard/sp4a12/main.c	(revision 413)
+++ branch/clara_soulard/sp4a12/main.c	(revision 414)
@@ -4,6 +4,12 @@
 #include "trame.h"
 #include <math.h>
 
+/***********************************************
+*
+* Définition des structures utiles au programme
+*
+************************************************/
+
 typedef struct {
 float latitude;
 float longitude;
@@ -23,7 +29,12 @@
                     "$GPGSA,A,3,,03,,22,14,,01,,18,,,,3.9,3.4,1.9*39",
                     "$GPVTG,99.4,T,,M,0.4,N,0.7,K*57",
                     "$GPZDA,141914.00,01,02,2006,00,00*69",
-                    0};
+
+                    0};
+
+
+/**Fonction qui compare une trame et renvoie si elle est conforme ou non **/
+
 int trame_cmp(char * trame, char * type)
 {
 int i=0;
@@ -45,7 +56,7 @@
         {
             if (trame[i+1]==type[i])
             {
-                ok=1;
+                ok=1; /** la trame est valide **/
             }
             else
             {
@@ -55,6 +66,8 @@
     }
     return ok;
 }
+
+/** Fonction qui prends en argument une chaîne de caractères (correspondant à un chiffre) et qui le caste en entier (int) **/
 int decode_int (char c)
 {
 int i=c-48;
@@ -64,83 +77,96 @@
         }
 return ok;
 }
-
+/** Même principe que decode_int mais avec une chaîne de caractère représentant un nombre **/
 int decode_nombre(char *ch,int n)
 {
-    int b=0;
-    int a=0;
-    int c=0;
-    int i;
+int a=0;
+int nb=0; /**contient le nombre qui était initialement une châine de caractères **/
+int i; /** compteur pour la boucle for **/
     for (i=0; i<=n-1; i++){
 
         a=decode_int(ch[i]);
-        c=c*10+a;
+        nb=nb*10+a; /** on multiplie par 10 pour décaler d'une dizaine **/
     }
 
-return c;
+return nb;
 }
+/**************************************************************************
+*
+* Fonctions qui convertisseurs la latitude puis la longitude en flottants
+*
+***************************************************************************/
 
-
 float convertisseur_latitude (char *ch)
 {
 
-    float lat=0.0;
-    float degre=(float)decode_nombre(ch,2);
-    float decim1=(float)decode_nombre(ch,4)-degre*pow(10,2);
+float latitude=0.0;
+float degre=(float)decode_nombre(ch,2);
+float decim1=(float)decode_nombre(ch,4)-degre*pow(10,2);
 
-    char chaine[50];
-    int i;
+char chaine[50]; /** chaîne qui va nous permettre de stocker les derniers caractères correspondant au derniers chiffres de la latitude **/
+int i;
     for (i=5; i<9; i++)
     {
         chaine[i-5]=ch[i];
     }
-    float decim2=(float)decode_nombre(chaine, 4); //ok
+    float decim2=(float)decode_nombre(chaine, 4); /** on récupère la fin de la chaîne pour ensuite la convertir **/
     decim1=decim1/60.0;
     decim2=decim2/600000.0;
-    lat=degre+decim1+decim2;
+    latitude=degre+decim1+decim2;
 
-    return lat;
+    return latitude;
     }
+
 float convertisseur_longitude (char *ch)
 {
-    float longi=0.0;
-    float degre=(float)decode_nombre(ch,3);
-    float decim1=(float)decode_nombre(ch,5)-degre*pow(10,2);
+float longitude=0.0;
+float degre=(float)decode_nombre(ch,3); /** on récupère dans un premier temps les degrés car ils ne subissent pas d'opération **/
+float decim1=(float)decode_nombre(ch,5)-degre*pow(10,2); /** on récupère ici les 3 premiers chiffres de la partie décimale **/
 
-    char chaine[50];
-    int i;
+char chaine[50]; /** chaîne qui va nous permettre de stocker les derniers caractères correspondant au derniers chiffres de la longitude **/
+int i;
     for (i=6; i<10; i++)
     {
-        chaine[i-6]=ch[i];
+        chaine[i-6]=ch[i]; /** on récupère la fin de la chaîne pour ensuite la convertir **/
     }
-    float decim2=(float)decode_nombre(chaine, 4); //ok
+    float decim2=(float)decode_nombre(chaine, 4);
     decim1=decim1/60.0;
     decim2=decim2/600000.0;
-    longi=degre+decim1+decim2;
+    longitude=degre+decim1+decim2;
 
-    return longi;
+    return longitude;
     }
 
+/** Fonction qui calcule indifféremment la latitude ou la longitude **/
 float latoulong (char *ch)
 {
  int i;
  i=strlen(ch);
- if (i==9)
- {
+    if (i==9)
+    {
      return convertisseur_latitude(ch);
- }
- else
- {
+    }
+    else
+    {
      return convertisseur_longitude(ch);
- }
+    }
 }
 
+/********************************************************************************************
+*
+* Fonctions qui calcule la distance en km entre deux trames et calcule de la vitesse en km/h
+*
+*********************************************************************************************/
+
+
 float calcul_distance(Position p_1, Position p_2)
 {
-    float S;
-    float R=6371.00; //rayon de la Terre
-    float P=2*M_PI*R;
-    float c=P/360.00;
+float S;
+float R=6371.00;  /**rayon de la Terre**/
+float P=2*M_PI*R;
+float c=P/360.00;
+
     S=c*pow((pow((p_2.latitude-p_1.latitude),2)+pow((p_2.longitude-p_1.longitude),2)),0.5);
     return S;
 }
@@ -147,49 +173,60 @@
 
 float calcul_vitesse(Position p_1, Position p_2)
 {
-    float vitesse;
-    float h=36000;
-    vitesse=calcul_distance(p_1, p_2)*36000;
+float vitesse;
+    vitesse=calcul_distance(p_1, p_2)*3600; /** on multiplie par 3600 car on donne un temps entre deux trames équivalent à 1s **/
     return vitesse;
 }
 
+/********************************************************************************************
+*
+* Fonction qui décode la trame et récupèrer la latitude et la longitude
+*
+*********************************************************************************************/
 
+
 int decode_trame(char* t, Position* p){
-    int ok,i;
-    char latitudecopie[9];  // chaine qui va contenir la latitude extraite de la trame
-    char longitudecopie[10]; //chaine qui va contenir la longitude extraite de la trame
+int ok,i;
+char latitudecopie[9];  /** chaine qui va contenir la latitude extraite de la trame **/
+char longitudecopie[10]; /** chaine qui va contenir la longitude extraite de la trame **/
 
-    ok=trame_cmp(t,"GPGGA");  // comparaison pour voir si la trame est valide
+    ok=trame_cmp(t,"GPGGA");  /** comparaison pour voir si la trame est valide à l'aide de la fonction faite au TP1 **/
     if(ok==1)
     {
         for(i=0;i<9;++i)
         {
-            latitudecopie[i]=t[17+i]; //on a un tableau contenant la latitude en chaîne de caractères
+            latitudecopie[i]=t[17+i]; /** on a un tableau contenant la latitude en chaîne de caractères **/
         }
          (*p).latitude=convertisseur_latitude(latitudecopie);
 
         for(i=0;i<10;++i)
         {
-            longitudecopie[i]=t[29+i]; //on a un tableau contenant la longitude en chaîne de caractères
+            longitudecopie[i]=t[29+i]; /** on a un tableau contenant la longitude en chaîne de caractères **/
 
         }
-        (*p).longitude=convertisseur_longitude(longitudecopie);
+        (*p).longitude=convertisseur_longitude(longitudecopie); /** on convertie la longitude en flottant pour l'utiliser ensuite si besoin est **/
 
     }else{
         exit(-1);
     } }
 
+/***********************************************************************************************
+*
+* Fonction qui repère la zone dangereuse la plus proche de là où se trouve l'utilisateur du GPS
+*
+************************************************************************************************/
+
 int distance_a_la_plus_proche_zone(Position p, Zone r[],int nb_zones, float *d)
 {   int i;
     float distance;
-    distance=calcul_distance(p, r[0].rpos); //initialise la premiere distance à comparer
-    int index; //variable que l'on retourne à la fin de la fonction
+    distance=calcul_distance(p, r[0].rpos); /** Initialise la premiere distance à comparer **/
+    int index; /** Variable que l'on retourne à la fin de la fonction **/
 
     for (i=0; i<nb_zones; i++)
 
     {
         *d=calcul_distance(p, r[i].rpos);
-        if (*d<=distance) //si la distance entre la position p et celle du radar à la i-ème position recensée est inférieur à la première distance calculée, distance prends cette valeur. on retrouvera ainsi de suite la zone dangereuse la plus près de la position de la voiture!
+        if (*d<=distance) /**si la distance entre la position p et celle du radar à la i-ème position recensée est inférieur à la première distance calculée, distance prends cette valeur. on retrouvera ainsi de suite la zone dangereuse la plus près de la position de la voiture! **/
         {
             distance=*d;
             index=i;
@@ -206,7 +243,7 @@
 
     if((trame[5]==65)&&(trame[4]==71)&&(trame[3]==71))
     {
-          printf ("> %s\n",trame);
+          //printf ("> %s\n",trame);
     }
 
 }
@@ -213,12 +250,17 @@
 
 //Ajouter vos tests unitaires dans cette fonction.
 void tests_unitaires(void){
+
+
     Position a={0.0, 1.0};
     Position *p;
-
     p=&a;
 
-
+    /******************************************
+    *
+    * Tests unitaires de différentes fonctions
+    *
+    *******************************************/
 
     if (5!=5){
         printf ("Erreur Test unitaire basique.\n");
@@ -258,7 +300,7 @@
      if(decode_nombre("789654",4)!=7896){
         printf("Erreur sur decode_nombre.\n");
     }
-    if(convertisseur_latitude("4545.1810")<45.7000 || convertisseur_latitude("4545.1810")>45.8000 ) //comme c'est des float on ne peut que encadrer la valeur
+    if(convertisseur_latitude("4545.1810")<45.7000 || convertisseur_latitude("4545.1810")>45.8000 ) /**comme c'est des float on ne peut que encadrer la valeur **/
     {
         printf("Erreur sur le convertisseur latitude");
     }
@@ -270,59 +312,104 @@
         printf("Erreur sur decode_trame");
     }
 
-      //tests de certaines fonction
+    /**********************************************************************************************************************************
+    *
+    * Tests de la fonction decode_trame et récupération de la latitude et la longitude des deux tests du sujet (TP2 question 5)
+    *
+    ***********************************************************************************************************************************/
 
-    Position pos;
-    pos.latitude=1;
-    pos.longitude=1;
-    Position *posi;
-    posi=&pos;
+Position pos;
+pos.latitude=1;
+pos.longitude=1;
+Position *posi;
+posi=&pos;
 
+Position position9, position8; /** Déclaration des positions qui contiendront les coordonées GPS des trames du sujet **/
 
-    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D", posi);
-    printf("position latitude: %f \n", (*posi).latitude);
-    printf("position longtitude: %f", (*posi).longitude);
 
-    Position position1, position2, position3, position4, position5,position6;
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D", &position8);
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*72", &position9);
+    //printf("position latitude trame 1: %f \n", position8.latitude); //on récupère les données des positions de la latitude de la trame 2 question 5
+    //printf("position longtitude trame 1: %f \n", position8.longitude);//on récupère les données des positions de la longitude de la trame 2 question 5
+    //printf("position latitude trame 2: %f \n", position9.latitude); //on récupère les données des positions de la latitude de la trame 2 question 5
+    //printf("position longtitude trame 2: %f \n", position9.longitude); //on récupère les données des positions de la longitude de la trame 2 question 5
 
-    //paris
-    position2.latitude=48.85666666666667;
-    position2.longitude=2.3519444444444444;
+    /**********************************************************************************************************************************
+    *
+    * Initialisation des coordonnées GPS de différentes villes de france pour tester les fonctions calcule_distance et calcule_vitesse
+    *
+    ***********************************************************************************************************************************/
 
-    //Rouen
-    position1.latitude=49.443888888888885;
-    position1.longitude=1.1033333333333335;
+    Position position1, position2, position3, position4, position5,position6, position7; //definitions des variables de type Position qui vont répertorier les différentes coordonnées des différentes villes
 
-    //lille
-    position3.latitude=50.63722222222222;
-    position3.longitude=3.063333333333333;
+    /** Paris **/
+position2.latitude=48.85666666666667;
+position2.longitude=2.3519444444444444;
 
-    //chalons
-    position4.latitude=48.9575;
-    position4.longitude=4.364999999999999;
+    /** Rouen **/
+position1.latitude=49.443888888888885;
+position1.longitude=1.1033333333333335;
 
-    //nice
-    position5.latitude=43.7;
-    position5.longitude=7.35;
+    /** Lille **/
+position3.latitude=50.63722222222222;
+position3.longitude=3.063333333333333;
 
+    /** Bordeaux **/
+position4.latitude=44.8404400;
+position4.longitude=-0.5805000;
 
-    printf("fonction test distance\n");
-    printf("Distance Paris-Rouen=%f\n", calcul_distance(position2, position1)); //Paris-Rouen = 135 km
-    printf("Distance Paris-Lille=%f\n", calcul_distance(position2, position3)); //Paris-Lille
-    printf("D2=%f\n", calcul_distance(position2, position4));
-    printf("D2=%f\n", calcul_distance(position2, position5));
+    /** Orléans **/
+position5.latitude=47.9028900;
+position5.longitude=1.9038900;
 
+    /** Polytech Clermont **/
+position6.latitude=45.77140808105469;
+position6.longitude=3.0903782844543457;
 
-    Zone zones[] = {{{44.7887762, -3.012}, 50},{{44.7891220, -3,013}, 70}};
-    float dist;
-    float *d;
-    d=&dist;
-    int c;
-    c=distance_a_la_plus_proche_zone(position1, zones, 2, d);
-    printf("zone dangereuse : %i \n", a);
+    /** Isima Clermont **/
+position7.latitude=45.75858688354492;
+position7.longitude=3.1108570098876953;
 
+
+    //printf("**** Test des distances entre plusieurs villes : ***** \n\n");
+    //printf("Distance Paris-Rouen=%f km\n", calcul_distance(position2, position1)); /**Paris-Rouen = 135 km**/
+    //printf("Distance Paris-Lille=%f km\n", calcul_distance(position2, position3)); /**Paris-Lille = 225 km**/
+    //printf("Distance Paris-Bordeaux=%f km\n", calcul_distance(position2, position4)); /**Paris-Bordeaux = 584 km**/
+    //printf("Distance Paris-Orleans=%f km\n\n", calcul_distance(position2, position5)); /**Paris-Orléans = 132 km**/
+    //printf("Distance entre les trames du sujet=%f km soit approximativement %.1f. m\n\n", calcul_distance(position8, position9), calcul_distance(position8, position9)*1000); /**distance entre les deux trames du sujet question 5**/
+
+
+    Zone zones[] = {{{44.7887762, -3.012}, 50},{{44.7891220, -3,013}, 70},{{45.7604, 3.120065}, 130}}; /**tableaux des zones dangereuses donné dans l'énoncé + une autre pour les tests**/
+float dist;
+int index;
+
+    /** Test de la fonction distance_a_la_plus_proche_zone **/
+    index=distance_a_la_plus_proche_zone(position9, zones, 3, &dist);
+    printf("**** Tests sur les zones dangereuses ***** \n\n");
+
+    printf("Index de la zone dangereuse la plus proche : %i.\n\n", index);
+float vitesse;
+int alarme;
+
+    vitesse=calcul_vitesse(position8, position9);
+
+    /** Affichage de la vitesse en km/h **/
+
+    printf("La vitesse du conducteur ou de la conductrice est de : %.0f km/h et la vitesse maximale autorisee est de : %.0f km/h.\n", vitesse, zones[index].vitmax);
+    if (vitesse>zones[index].vitmax) /** si la vitesse est supérieure au seuil autorisé alors l'alarme va s'activer car le conducteur ou la conductrice roule trop vite **/
+    {
+        printf("Alarme : active. Vous êtes au dessus de la limitation. \n\n");
+        alarme=1;
+    }
+    else
+    {
+        printf("Alarme : non active. \n\n"); /** le conducteur est en dessous de la vitesse maximale autorisée : pas besoin de déclancher l'alarme **/
+        alarme=0;
+    }
+    printf("La vitesse entre l'utilisateur du GPS et la prochaine zone dangereuse est de : %.2f km soit %.0f m.", dist, dist*1000);
+}
+
 
-}
 
 // Ne pas modifier cette fonction
 int main(int argc,char ** argv)
@@ -331,7 +418,7 @@
     tests_unitaires();
 
     // Affichage des trames definies dans la table trames.
-    printf ("Trames de tests tableau trames:\n");
+    //printf ("Trames de tests tableau trames:\n");
     int i=0;
     while (trames[i])
         traitement(trames[i++]);
@@ -340,7 +427,7 @@
         exit(-1);
     // Affichage des trames du fichier gps.log
     char *trame;
-    printf ("Trames de tests du fichier gps.log\n");
+    //printf ("Trames de tests du fichier gps.log\n");
     while  ((trame = trame_suivante()))
         traitement(trame);
 