Index: branch/FOUCHER_Louis/sp4a12/main.c
===================================================================
--- branch/FOUCHER_Louis/sp4a12/main.c	(revision 417)
+++ branch/FOUCHER_Louis/sp4a12/main.c	(revision 418)
@@ -18,22 +18,19 @@
     float latitude;
     float longitude;
 }Position;
-Position p;
-
-//Fonction à modifier !!!!!
-void traitement(char * trame)
-{
-    static int cpt=0;
-    cpt++;
 
-    printf("long : %f, lat : %f\n", p.longitude, p.latitude);
+Position p, p1, p2, p3;
 
-    if (trame_cmp(trame,"GPGGA")==1)
-    {
-        printf ("> %s\n",trame);
-    }
-}
+typedef struct {
+    Position zpos;
+    float vitMax;
+}Zone;
 
+Zone zones[] = {
+    {{44.7887762, -3.012}, 50},     //Descripteur de la premiere zone
+    {{44.7891220, -3.013}, 70}
+};
+
 int trame_cmp(char *trame, char *type)
 {
     int i=0, res=1;
@@ -102,39 +99,109 @@
     return res;
 }
 
-int decode_trame (char* trame, Position* p){
-    int t=0;
-    int i=0;
-    int j=7;
-    int k=18;
-    if (trame_cmp(trame,"GPGGA")==1){
-        t=1;
-        i=7;
-        for (j=7;j<17;j++){
+void decode_trame(char *trame, Position *p) {
 
-            trame[i]=trame[j];
-            i++;
-        }
-        i=7;
-        do{
-            p->longitude=conv_sexa_decimal(trame);
-            i++;
-        }while(trame[i]!=',');
+	int i = 17, cmpt = 0;           //debut codage latitude caractere 17 de la trame
+    char lat[10], lon[10];
+
+    do {
+        lat[cmpt] = trame[i];
         i++;
-        for (k=18;k<28;k++){
-            trame[i]=trame[k];
+        cmpt++;
+    } while (trame[i] != ',');
+
+	cmpt = 0;
+    i = 29;         //debut codage longitude caractere 29 de la trame
+
+    do {
+        lon[cmpt] = trame[i];
+        i++;
+        cmpt++;
+    } while (trame[i] != ',');
+
+	(*p).latitude = conv_sexa_decimal(lat);
+	(*p).longitude = conv_sexa_decimal(lon);
+}
+
+float calcule_distance(Position p1, Position p2){
+    float x, y, dist;
+
+    //Pythagore
+    x=(p2.longitude - p1.longitude)*cos((p2.latitude + p1.latitude)/2);
+    y=(p2.latitude - p1.latitude);
+
+    dist = (sqrt((x*x)+(y*y)))*1.852*60; //*1.852*60 -> km
+
+    return dist;
+}
+
+float calcule_vitesse(Position p1, Position p2) {
+    float vit;
+
+    vit = calcule_distance(p1, p2) * 3600; //*3600 -> km/h, v=d/t
+
+    return vit;
+}
+
+int distance_a_la_plus_proche_zone(Position p, Zone z[], int nb_zones, float *dist) {
+    int i, size_z;
+
+    *dist = calcule_distance(p, z[0].zpos); //distance entre Position et la position de la zone dangereuse
+
+    nb_zones = 0;
+
+    size_z = sizeof(*z);
+
+    for(i=1;i<size_z;i++) {
+        if ( calcule_distance(p, z[i].zpos) < *dist ) {
+            *dist = calcule_distance(p, z[i].zpos);
+            nb_zones = i;
         }
-        do{
-            p->latitude=conv_sexa_decimal(trame);
-            i++;
-        }while(trame[i]!='\0');
     }
-    else t=0;
-    return t;
+
+    return nb_zones;
 }
+
+//Fonction à modifier !!!!!
+void traitement(char * trame)
+{
+    static int cpt=0;
+    float v, d;
+    int nb_zones, alarme = 0, dist_seuil = 5, dist;
+    //printf("%s\n", alarme);
+    cpt++;
+
+    if (trame_cmp(trame,"GPGGA")==1)
+    {
+        decode_trame(trame, &p);
+        printf ("> %s\n",trame);
+
+        v = calcule_vitesse(p, p1);
+        dist = distance_a_la_plus_proche_zone(p, zones, nb_zones, &d);
+
+        if ((dist < dist_seuil) && (v > zones[dist].vitMax)){
+            alarme = 1;
+            if (alarme == 1) printf ("Alarme : ON\n");
+            printf ("ATTENTION vous roulez a %f, la chaussee est limite a %f.\n", v, zones[dist].vitMax);
+            alarme = 0;
+        }
+        else {
+           if (alarme == 0) printf ("Alarme : OFF\n");
+           printf ("Vous roulez a %f.\n", v);
+        }
+
+        p = p1;
+        //printf("long : %f, lat : %f\n", p.longitude, p.latitude);
+    }
+
+}
+
 
 //Ajouter vos tests unitaires dans cette fonction.
-void tests_unitaires(void){
+void tests_unitaires(void){
+    float x, y, a, b, d, v, dz;
+    int nb_zones;
+
     if (5!=5){
         printf ("Erreur Test unitaire basique.\n");
         exit(-1);
@@ -167,19 +234,60 @@
         printf ("Erreur Test unitaire decode_nombre.\n");
         exit(-1);
     }
-    /*printf("%f\n", conv_sexa_decimal("3723.2475"));
-    if (conv_sexa_decimal("3723.2475")!=37.387459){
+    x = 37.387458 - conv_sexa_decimal("3723.2475");
+    y = 3.11006 - conv_sexa_decimal("00306.6036");
+    if (x > 0.000001){
         printf ("Erreur Test unitaire conv_sexa_decimal.\n");
         exit(-1);
     }
-    /*printf("%f\n", conv_sexa_decimal("00306.6036"));
-    if (conv_sexa_decimal("00306.6036")!=3.11006){
+    if (y > 0.000001){
         printf ("Erreur Test unitaire conv_sexa_decimal.\n");
         exit(-1);
-    }*/ //test unnitaire ne fonctionne pas, je ne sais pas pourquoi
-    if (decode_trame("$GPGGA,4545.0000,00306.6036", &p)!=1){
-        printf ("Erreur Test unitaire decode_trame.\n");
+    }
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*7D",&p);
+    a= 3.110061 - p.longitude;
+    b= 45.75 - p.latitude;
+    if ((a > 0.000001) && (b > 0.000001)) {
+        printf("Erreur Test unitaire decode_trame.\n");
         exit(-1);
+    }
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75",&p);
+    a= 3.110066 - p.longitude;
+    b= 45.750403 - p.latitude;
+    if ((a > 0.000001) && (b > 0.000001)) {
+        printf("Erreur Test unitaire decode_trame.\n");
+        exit(-1);
+    }
+    decode_trame("$GPGGA,141917.00,4545.0726,N,00306.6039,E,1,05,3.4,499.6,M,,M,,*73",&p);
+    a= 3.110066 - p.longitude;
+    b= 45.751209 - p.latitude;
+    if ((a > 0.000001) && (b > 0.000001)) {
+        printf("Erreur Test unitaire decode_trame.\n");
+        exit(-1);
+    }
+    decode_trame("$GPGGA,141918.00,4545.0968,N,00306.6034,E,1,05,3.4,498.8,M,,M,,*7A",&p);
+    a= 3.110057 - p.longitude;
+    b= 45.751614 - p.latitude;
+    if ((a > 0.000001) && (b > 0.000001)) {
+        printf("Erreur Test unitaire decode_trame.\n");
+        exit(-1);
+    }
+    decode_trame("$GPGGA,141914.00,4545.0000,N,00306.6036,E,1,05,3.4,499.3,M,,M,,*79",&p1);
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75",&p2);
+    d = 0.044932 - calcule_distance(p1, p2);
+    if (d > 0.000001) {
+        printf("Erreur Test unitaire calcule_distance.\n");
+        exit(-1);
+    }
+    v = 161.756485 - calcule_vitesse(p1, p2);
+    if (v > 0.000001) {
+        printf("Erreur Test unitaire calcule_vitesse.\n");
+        exit(-1);
+    }
+    decode_trame("$GPGGA,141915.00,4545.0242,N,00306.6039,E,1,05,3.4,499.5,M,,M,,*75", &p3);
+    if (distance_a_la_plus_proche_zone(p3, zones, nb_zones, &dz) != 1 ) {
+        printf("Erreur Test unitaire distance_a_la_plus_proche_zone.\n");
+        exit(-1);
     }
 }
 